using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace cForm
{
    public partial class cForm : Form
    {
        Color backColor;
        Pen greedPen;
        Pen pen0;
        SolidBrush br;

        Random rnd;

        xPoint[] pt;

        const int nPT = 5000;

        const int minHeight = 100;
        const int minWidth = 100;
        const int maxHeight = 950;
        const int maxWidth = 950;

        public double rPoint;

        int borderHeight;
        int borderWidth;

        private Bitmap bmp;

        private System.Windows.Forms.Timer mainTimer;

        public cForm()
        {
            int i;
            rnd = new Random();

            backColor = Color.FromArgb(255,0,0,0);

            greedPen = new Pen(Color.FromArgb(50, 0, 0, 255), 1);
            pen0 = new Pen(Color.FromArgb(255,0,0,0),1);
            br = new SolidBrush(Color.FromArgb(0, 0, 0, 0));

            InitializeComponent();
            GetBordersGabarits();
            bForm00_Layout(null, null);
            SetMinMaxSize();

            pt = new xPoint[nPT];
            for (i = 0; i < pt.Length; i++)
            {
            pt[i] = new xPoint(
                               (int)(this.ClientSize.Width  / (2*rPoint)),
                               (int)(this.ClientSize.Height / (2*rPoint)),
                               0,
                               0
                               );
            }

            mainTimer.Start();
        }

        //    rPoint   .
        //   !      .
        //          value!
        private Size rPointSet
        {            
            set
            { 
             Size s = value;
             rPoint = Math.Sqrt(2.0*s.Width*s.Height) * 0.002;            
            }        
        }

        //     !       .
        private double rPointGet
        {
            get
            {
                return rPoint;
            }
        }        
                
        private void bForm00_Paint(object sender, PaintEventArgs e)
        {
            xRedraw(); 
        }
  
        private void DrawGreed(Graphics gr)
        {
            float i;
            float w = (float)(this.ClientSize.Width / 25.0F), h = (float)(this.ClientSize.Height / 25.0F);
            float W = this.ClientSize.Width, H = this.ClientSize.Height;

            for (i = h; i < H; i += h)
            {
                gr.DrawLine(this.greedPen, 0, i, W, i);
            }

            for (i = w; i < W; i += w)
            {
                gr.DrawLine(this.greedPen, i, 0, i, H);
            }
        }

        private void xRedraw()
        {
            Graphics gr = Graphics.FromImage(bmp);

            gr.Clear(backColor);
            DrawGreed(gr);
            foreach (xPoint xp in pt)
            {
                br.Color = xp.xColor;
                gr.FillEllipse(br, (float)((xp.p.X * rPoint) - rPoint), (float)((xp.p.Y * rPoint) - rPoint), (float)(2*rPoint), (float)(2 * rPoint));
                pen0.Color = xp.xColor;
                gr.DrawEllipse(pen0, (float)((xp.p.X * rPoint) - rPoint), (float)((xp.p.Y * rPoint) - rPoint), (float)(2*rPoint), (float)(2*rPoint));
            }
            gr.Dispose();
            this.mainPictureBox.Image = bmp;
        }
       
        //  Layout        ,
        //       ,
        //      ,      .
        //     ,   ..._Resize  ..._SizeChanged.
        //  Layout       ..._Resize  ..._SizeChanged,
        //     ,     .
        private void bForm00_Layout(object sender, LayoutEventArgs e)
        {
         //     -      !
         //        
         //    (     ).
         //       . 

                Size = new System.Drawing.Size
                    (
                    (ClientSize.Width + ClientSize.Height)/2 + borderWidth,
                    (ClientSize.Width + ClientSize.Height)/2 + borderHeight
                    );

                //     -    rPoint, 
                //      rPointSet.   
                rPointSet = this.ClientSize;
                //        .
                bmp = new Bitmap(this.ClientSize.Width, this.ClientSize.Height);
                this.Invalidate(false); 
        }

        //    . Ÿ    
        //          (X  Y).
        //        ,      "" 
        //     (""  ""   Y  ""  ""   X).    
        private void setNextPosition()
        {
            int i,j;
            float xy;

            for (i = 0; i < pt.Length; i++)
            {

                xy = (float)((pt[i].p.X + pt[i].direction.X) * rPoint);
                if (xy < 0 || xy > this.ClientSize.Width || pt[i].n.X > 1 )
                {
                    for (j = 0; j < 10; j++)
                    {
                        pt[i].direction.X = rnd.Next(-1, 2);
                        xy = (float)((pt[i].p.X + pt[i].direction.X) * rPoint);
                        if (xy >= 0 && xy <= this.ClientSize.Width)
                        {
                            pt[i].p.X += pt[i].direction.X;
                            pt[i].n.X = 0;
                            break;
                        }
                    }
                }
                else
                {
                    pt[i].p.X += pt[i].direction.X;
                    pt[i].n.X++;
                }

                xy = (float)((pt[i].p.Y + pt[i].direction.Y) * rPoint);
                if (xy < 0 || xy > this.ClientSize.Height || pt[i].n.Y > 1 )
                {
                    for (j = 0; j < 10; j++)
                    {
                        pt[i].direction.Y = rnd.Next(-1, 2);
                        xy = (float)((pt[i].p.Y + pt[i].direction.Y) * rPoint);
                        if (xy >= 0 && xy <= this.ClientSize.Height)
                        {
                            pt[i].p.Y += pt[i].direction.Y;
                            pt[i].n.Y = 0;
                            break;
                        }
                    }
                }
                else
                {
                 pt[i].p.Y += pt[i].direction.Y;
                 pt[i].n.Y++;
                }
            }
        }

        private void mainTimer_Tick(object sender, EventArgs e)
        {
            setNextPosition();
            xRedraw();
        }
        
    }
}