using System;
using System.Data;

namespace DataColumnsApplication00
{
class DataTester
{
DataTable custTable;

public void DTBuild()
{
custTable = new DataTable("Customers");
//  .
custTable.Columns.Add("id", typeof(int));
custTable.Columns.Add("name", typeof(string));

//   .
custTable.Columns["id"].Unique = true;
custTable.PrimaryKey = new DataColumn[] { custTable.Columns["id"] };

//   ColumnChanging handler  .
custTable.ColumnChanging +=
                      new DataColumnChangeEventHandler(Column_Changing);
//   ColumnChanged event handler  . 
custTable.ColumnChanged +=
                      new DataColumnChangeEventHandler(Column_Changed);
}

public void RowsAdd(int id)
{
int x;
//  .
for (x = 0; x < id; x++)
{
    custTable.Rows.Add(new object[] { x, string.Format("customer{0}", x) });
}
//   ,     
//     AcceptChanges. 
custTable.AcceptChanges();
}

public void RowsChange()
{
//    name   .
foreach (DataRow row in custTable.Rows)
{
    row["name"] = string.Format("vip{0}", row["id"]);
}


}

//      
//  . Column_Changing.  
private static void Column_Changing(object sender, DataColumnChangeEventArgs e)
{
    Console.WriteLine
    ("Column_Changing Event: name={0}; Column={1}; proposed name={2}", 
                                                        e.Row["name"], 
                                                  e.Column.ColumnName,
                                                       e.ProposedValue);
}

//   . Column_Changed.
    private static void Column_Changed(object sender, DataColumnChangeEventArgs e)
{
    Console.WriteLine
    ("Column_Changed Event: name={0}; Column={1}; proposed name={2}",
                                                       e.Row["name"],
                                                 e.Column.ColumnName,
                                                     e.ProposedValue);
}    
}
class Program
{
 static void Main(string[] args)
 {
  DataTester dt = new DataTester();
   dt.DTBuild();
   dt.RowsAdd(10);
   dt.RowsChange();
  }
 }
}
