using System;
using System.Data;

namespace DataRowsApplication00
{
class DataTester
{
DataTable custTable;

public void DTBuild()
{
custTable = new DataTable("Customers");
//  .
custTable.Columns.Add("id", typeof(int));
custTable.Columns.Add("name", typeof(string));

//   .
custTable.Columns["id"].Unique = true;
custTable.PrimaryKey = new DataColumn[] { custTable.Columns["id"] };

//  RowChanging event handler   .
custTable.RowChanging += new DataRowChangeEventHandler(Row_Changing);
//  a RowChanged event handler   .
custTable.RowChanged += new DataRowChangeEventHandler(Row_Changed);
}

public void RowsAdd(int id)
{
int x;
//  .
for (x = 0; x < id; x++)
{
    custTable.Rows.Add(new object[] { x, string.Format("customer{0}", x) });
}
//   ,     
//     AcceptChanges. 
custTable.AcceptChanges();
}

public void RowsChange()
{
//    name   .
//   ,    
//  ,  
//  vip      .
//   customer5   vip customer5.

foreach (DataRow row in custTable.Rows)
{
    row["name"] = string.Format("vip {0}", row["id"]);
}

}

//      
//  . Row_Changing.  
private static void Row_Changing(object sender, DataRowChangeEventArgs e)
{
Console.WriteLine("Row_Changing Event: name={0}; action={1}",
                                                e.Row["name"],
                                                     e.Action);
}

//   . Row_Changed.
private static void Row_Changed(object sender, DataRowChangeEventArgs e)
{
Console.WriteLine("Row_Changed Event: name={0}; action={1}",
                                               e.Row["name"],
                                                    e.Action);
}    
}
class Program
{
 static void Main(string[] args)
 {
  DataTester dt = new DataTester();
   dt.DTBuild();
   dt.RowsAdd(10);
   dt.RowsChange();
              }
 }
}
