using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Map_00
{

	public class MapForm : System.Windows.Forms.Form
	{   
		Bitmap bmp;
		Pen pen;
		Pen linePen;
		Pen pixelPen;
		Queue qPoints;
		private Panel mapPanel;
		const int maxSizeVal = 1000;
		const int minSizeVal = 100;
		Size frameSize;
		float radius;
        public float hFactor;

		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuSetHeightFactor;
            
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MapForm()
		{   
			bmp = new Bitmap(1,1);
			hFactor = 1.0F;
			pixelPen = new Pen(Color.FromArgb(255,200,100),1);
			pen = new Pen(Color.FromArgb(10,10,10,200),1);
			linePen = new Pen(Color.FromArgb(100,255,255,255),1);
			qPoints = new Queue();
			InitializeComponent();
			frameSize = new Size(this.Size.Width - this.ClientSize.Width, this.Size.Height - this.ClientSize.Height);
			this.MaximumSize = new Size(maxSizeVal+frameSize.Width, maxSizeVal+frameSize.Height);    	 
			this.MinimumSize = new Size(minSizeVal+frameSize.Width, minSizeVal+frameSize.Height);
			Size = new Size(MinimumSize.Width*5,MinimumSize.Height*5);
		}


		void SetRadius()
		{
			radius = (float)(mapPanel.ClientSize.Width*Math.Sqrt(2.0)/50.0);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mapPanel = new System.Windows.Forms.Panel();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuSetHeightFactor = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// mapPanel
			// 
			this.mapPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.mapPanel.BackColor = System.Drawing.SystemColors.Control;
			this.mapPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.mapPanel.Location = new System.Drawing.Point(0, 0);
			this.mapPanel.Name = "mapPanel";
			this.mapPanel.Size = new System.Drawing.Size(324, 344);
			this.mapPanel.TabIndex = 0;
			this.mapPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.mapPanel_Paint);
			this.mapPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.mapPanel_MouseDown);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuSetHeightFactor});
			// 
			// menuSetHeightFactor
			// 
			this.menuSetHeightFactor.Index = 0;
			this.menuSetHeightFactor.Text = "SetHeihgtFactor";
			this.menuSetHeightFactor.Click += new System.EventHandler(this.menuSetHeightFactor_Click);
			// 
			// MapForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(312, 329);
			this.Controls.Add(this.mapPanel);
			this.Cursor = System.Windows.Forms.Cursors.Cross;
			this.Menu = this.mainMenu1;
			this.Name = "MapForm";
			this.Text = "MapForm";
			this.Resize += new System.EventHandler(this.MapForm_Resize);
			this.SizeChanged += new System.EventHandler(this.MapForm_SizeChanged);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MapForm());
		}

		private void mapPanel_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
        
		    e.Graphics.DrawImage(bmp,0,0); 
     
			int X,x,Y,y,xStep,yStep;

			foreach(MapPointF mpf in qPoints)
			{
				e.Graphics.DrawEllipse(pen,
										(int)Math.Ceiling(mpf.pf.X*radius - radius*0.5),
										(int)Math.Ceiling(mpf.pf.Y*radius - radius*0.5),
										(int)Math.Ceiling(radius),
										(int)Math.Ceiling(radius)
				);
				e.Graphics.DrawLine(pixelPen,
										(int)Math.Ceiling(mpf.pf.X*radius - radius*0.1),
										(int)Math.Ceiling(mpf.pf.Y*radius),
										(int)Math.Ceiling(mpf.pf.X*radius + radius*0.1),
										(int)Math.Ceiling(mpf.pf.Y*radius)
				);
				e.Graphics.DrawLine(pixelPen,
										(int)Math.Ceiling(mpf.pf.X*radius),
										(int)Math.Ceiling(mpf.pf.Y*radius - radius*0.1),
										(int)Math.Ceiling(mpf.pf.X*radius),
										(int)Math.Ceiling(mpf.pf.Y*radius + radius*0.1)
				);
			}

			for(x=0,  X = mapPanel.ClientSize.Width, y = 0, Y = mapPanel.ClientSize.Height, xStep = (int)Math.Ceiling(mapPanel.ClientSize.Width/10.0);
				x <= X;
				x+=xStep)
			{
			 e.Graphics.DrawLine(linePen,x,y,x,Y);			
			}

			for(x=0,  X = mapPanel.ClientSize.Width, y = 0, Y = mapPanel.ClientSize.Height, yStep = (int)Math.Ceiling(mapPanel.ClientSize.Height/10.0);
				y <= Y;
				y+=yStep)
			{
				e.Graphics.DrawLine(linePen,x,y,X,y);			
			}
				
		}

		private void mapPanel_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			qPoints.Enqueue(new  MapPointF((float)(e.X/radius),(float)(e.Y/radius), hFactor));
			SetPick();
	   		mapPanel.Invalidate(true);
		}


		private Color SetColor(int grade)
		{
			switch (grade)
			{
				case(10): return (Color)MapColors.colorArray[20];
				case( 9): return (Color)MapColors.colorArray[19];
				case( 8): return (Color)MapColors.colorArray[18];
				case( 7): return (Color)MapColors.colorArray[17];
				case( 6): return (Color)MapColors.colorArray[16];
				case( 5): return (Color)MapColors.colorArray[15];
				case( 4): return (Color)MapColors.colorArray[14];
				case( 3): return (Color)MapColors.colorArray[13];
				case( 2): return (Color)MapColors.colorArray[12];
				case( 1): return (Color)MapColors.colorArray[11];
				case( 0): return (Color)MapColors.colorArray[10];
				case(-1): return (Color)MapColors.colorArray[9];
				case(-2): return (Color)MapColors.colorArray[8];
				case(-3): return (Color)MapColors.colorArray[7];
				case(-4): return (Color)MapColors.colorArray[6];
				case(-5): return (Color)MapColors.colorArray[5];
				case(-6): return (Color)MapColors.colorArray[4];
				case(-7): return (Color)MapColors.colorArray[3];
				case(-8): return (Color)MapColors.colorArray[2];
				case(-9): return (Color)MapColors.colorArray[1];
				case(-10): return (Color)MapColors.colorArray[0];		
			};	
	
			  if      (grade > 10)
				      return Color.FromArgb(255,35,0);
			  else if (grade < -10)
				      return Color.FromArgb(0,35,255);

			  return  Color.FromArgb(255,255,255);
		}


		private float SetPicLevel(float x, float y)
		{
		 float summ = 0, distance;

			if (qPoints.Count == 0) return 0.0F; 

			foreach(MapPointF mpf in qPoints)
			{

             distance = FindDistance(mpf.pf.X*radius,mpf.pf.Y*radius,x,y);
             if (distance < radius) distance = radius;
			 summ += (float)(mpf.hFactor*radius/distance);
			}         
		 return (float)summ;
		}

		private void SetPick()
		{
			Color clr;
			int x,y,X = bmp.Size.Width,Y = bmp.Size.Height;
			float res;
          
			for (x = 0; x < X; x++)
			{
				for (y = 0; y < Y; y++)
				{
					res = SetPicLevel((float)x, (float) y);
					clr = SetColor((int) res); 
					bmp.SetPixel(x,y,clr);					
				} 			
			}
		}
				
		
		float FindDistance(float x0, float y0, float x1, float y1)
		{
         float XX = (float)Math.Pow((x0-x1),2.0);
		 float YY = (float)Math.Pow((y0-y1),2.0);
		 return (float) Math.Ceiling(Math.Sqrt(XX+YY));
		}

		private void menuSetHeightFactor_Click(object sender, System.EventArgs e)
		{
		 HeightFactorDialog hfd = new HeightFactorDialog(this);
         hfd.ShowDialog();
		}
		


		private void MapForm_Resize(object sender, System.EventArgs e)
		{
			if (ClientSize.Height != ClientSize.Width)
			{
				ClientSize = new Size(ClientSize.Width,ClientSize.Width);
				mapPanel.Size = new Size(ClientSize.Width, ClientSize.Height);
			}

		}
			

		private void MapForm_SizeChanged(object sender, System.EventArgs e)
		{
				if (!bmp.Size.Equals(mapPanel.ClientSize))
				{						
					bmp = new Bitmap(mapPanel.ClientSize.Width, mapPanel.ClientSize.Height);
					SetRadius();
					SetPick();
					mapPanel.Invalidate(true);
				}
		}

	}


	public class MapColors
	{
		public static Color [] colorArray = new Color[]
	{
				Color.FromArgb(0,55,255),
				Color.FromArgb(0,75,235),
				Color.FromArgb(0,95,215),
				Color.FromArgb(0,115,195),
				Color.FromArgb(0,135,175),
				Color.FromArgb(0,155,155),
				Color.FromArgb(0,175,135),
				Color.FromArgb(0,195,115),
				Color.FromArgb(0,215,95),											
				Color.FromArgb(0,235,75),
															
				Color.FromArgb(55,255,55),
																	
				Color.FromArgb(75,235,0),
				Color.FromArgb(95,215,0),
				Color.FromArgb(115,195,0),
				Color.FromArgb(135,175,0),
				Color.FromArgb(155,155,0),
				Color.FromArgb(175,135,0),
				Color.FromArgb(195,115,0),
				Color.FromArgb(215,95,0),
				Color.FromArgb(233,75,0),
				Color.FromArgb(255,55,0),	
	};	
	


	
	}

	class MapPointF
	{
		public const int AllPonts = 10;
		public float hFactor;
		public PointF pf;
		public MapPointF(float X, float Y, float hFactorKey)
		{
			pf = new PointF(X, Y);
			hFactor = hFactorKey;
		}
	}

}
