using System;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Text;

namespace derivedForm
{
    class FallControl
    {
        Queue<float> qAccel;
        IEnumerator<float> en;
  
        public PointF startPosition;
        public PointF memPosition;
        public PointF currentPosition;
        float accel, wAccel;
        float v0;
        float lastAccel; 
        Ressore00 ressore;
        Cargo00 cargo;
        Tracer00 tracer;

        public int nTime;
        public int n;
        public int K;
        public int R;
        //      .
        int dChange;          //     
       
        public FallControl(
                           PointF position,
                           float accel,
                           float v0,
                           Ressore00 ressore,
                           Cargo00 cargo,
                           Tracer00 tracer,
                           int K,
                           int R
                           )
        {
            this.startPosition = new PointF(position.X, position.Y);
            this.memPosition = new PointF(position.X, position.Y);
            this.currentPosition = new PointF(position.X, position.Y);
            nTime = 0;
            this.accel = accel;
            this.wAccel = accel;
            this.v0 = v0;
            this.ressore = ressore;
            this.cargo = cargo;
            this.tracer = tracer;
            n = 0;
            dChange = 1; 
            this.K = K;
            this.R = R;
            qAccel = new Queue<float>();
            xQueue = wAccel;
        }

        public void ReSetFC()
        {
            startPosition.X = memPosition.X;
            startPosition.Y = memPosition.Y;
   
            currentPosition = new PointF(startPosition.X, startPosition.Y);
            
            wAccel = accel;
            nTime = 0;
            n = 0;
            dChange = 1;
            qAccel.Clear(); //  .
            xQueue = wAccel;
 
        }
                
        //       .
        //     accel.
        public PointF yEuler00()
        {
         float vFall = v0; 
         int i;
         float Y = startPosition.Y;
         nTime++;
         for (i = 1; i <= nTime; i++)
         {
             vFall += (accel * i);
             Y += vFall; 
         }

         PointF tmp = new PointF(startPosition.X, Y - currentPosition.Y);

         currentPosition = new PointF(
                                      startPosition.X,
                                      Y 
                                      );
         return tmp;
        }

        //       .
        //     accel.
        //      , 
        //     . 
        

        public float xQueue
        {
            set
            {
                qAccel.Enqueue(value);
                //     -  .
                en = qAccel.GetEnumerator(); 
            }
            get
            {
                //     .
                if (en.MoveNext()) { lastAccel = en.Current; return lastAccel; }
                else               {                         return lastAccel; } 
            }
        }

        public PointF yEuler01()
        {
            bool change = false;
            PointF pTmp;
            float antiAccel;
            float vFall = v0;
            int i;
            float Y = startPosition.Y;
            nTime++;

            for (i = 1; i <= nTime; i++)
            {
                vFall += (xQueue * ressore.RD * i);
                Y += vFall;
            }

            //  .     
            //  ,     .
            //     !
            antiAccel = (float)(Y * ressore.kR / cargo.mass);
            //  , ...
            xQueue = xQueue - antiAccel;


            //     ...   
            //       
            //   .
            if (Y > currentPosition.Y)
            {
                pTmp = new PointF(startPosition.X, Y - currentPosition.Y);
                if (dChange < 0)
                {
                    dChange = 1;
                    nTime = 0;
                    change = true;
                }
            }
            else if (Y < currentPosition.Y)
            {
                pTmp = new PointF(startPosition.X, currentPosition.Y - Y);
                if (dChange > 0)
                {
                    dChange = -1;
                    nTime = 0;
                    change = true;
                }
            }
            else
            {
                pTmp = new PointF(startPosition.X, 0.0F);
            }


            currentPosition = new PointF(startPosition.X, Y);

            if (change) 
            {
                startPosition.Y = currentPosition.Y;
                ressore.ChangeRD();
            }
            
    
            if (dChange > 0 && nTime == 0) n++;

            return pTmp;
        }


        //       .
        //     (accel*t)    
        // .    .
        public PointF yLiner00(float t)
        {
            nTime++;
            PointF tmp; 

            if (currentPosition.Y > startPosition.Y)
            {
                tmp = new PointF(startPosition.X, accel*t);
                currentPosition = new PointF(
                                              startPosition.X,
                                              currentPosition.Y - (accel*t)
                                             );
            }
            else //   .   .
            {
                tmp = new PointF(startPosition.X, currentPosition.Y - startPosition.Y);
                currentPosition = new PointF(
                                              startPosition.X,
                                              currentPosition.Y - (currentPosition.Y - startPosition.Y)
                                             );
            }

            return tmp;
        }

        public void Demo00()
        {
            n++;
            PointF p;

            if (ressore.RD > 0) // K     .
            {
                p = yEuler00();
                ressore.Step = p.Y;
                ressore.rDown();
                tracer.xQueue = new Cargo00(
                                            ressore.c.cargoSize,
                                            ressore.c.position,
                                            ressore.c.mass,
                                            ressore.c.force
                                            );
             
                if (n == K)
                {
                    n = 0;
                    ressore.ChangeRD();
                }

            }
            else  // R     .
            {
                p = yLiner00(100.0F);
                ressore.Step = p.Y;
                ressore.rDown();
                tracer.xQueue = new Cargo00(
                                            ressore.c.cargoSize,
                                            ressore.c.position,
                                            ressore.c.mass,
                                            ressore.c.force
                                            );

                if (n == R)
                {
                    ReSetFC();
                    n = 0;
                    ressore.ChangeRD();
                }
            }
        
        }

        public void Demo01()
        {
            PointF p;

               p = yEuler01();
                ressore.Step = p.Y;
                ressore.rDown();
                tracer.xQueue = new Cargo00(ressore.c.cargoSize, ressore.c.position, ressore.c.mass, ressore.c.force);

                if (n == K) ReSetFC();
        }

    }
}
