using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using winLibrary00;

namespace derivedForm
{

    public partial class dForm : xForm00
    {
             
        const int nTr = 300;

        FallControl fc;
        Ressore00 r;
        Cargo00 c;
        Tracer00 tc;

        Pen rPen, cPen, ctrPen;
        SolidBrush cBr, ctrBr;

        
        public dForm(Color cKey, Color gKey)
            : base(cKey, gKey)
        {
            rPen = new Pen(Color.FromArgb(175, 255, 0, 0));

            cPen = new Pen(Color.FromArgb(175, 0, 0, 0));
            cBr = new SolidBrush(Color.FromArgb(100, 0, 0, 10));

            ctrPen = new Pen(Color.FromArgb(25, 0, 0, 0));
            ctrBr = new SolidBrush(Color.FromArgb(10, 0, 0, 10));

            InitializeComponent();
            r = new Ressore00(
                              15, 1,   //   .               
                              1,       //    .
                              1,       //    . 
                              50,      //   .
                              25,      //   .
                              50,      //   .
                              0.0F,    //   .
                              1.0F,    //  .
                              0.25F    //   .
                              );

            c = new Cargo00(
                          new Size(10, 10),   //  .               
                          new Point(10, 10),  //  .
                          700.0F,             // . 
                          0                   // .
                          );

            c.r = r;
            r.c = c;

            tc = new Tracer00(nTr, 1.0F, 0.0F);

            //    .
            //      . 
            r.rDown();
            //    . 
            r.Step = 1.0F;

            fc = new FallControl(new PointF(c.Position.X, c.Position.Y),
                                 0.5F,//0.1F,
                                 0.0F,
                                 r,
                                 c,
                                 tc,
                                 10, //22,
                                 0  //25
                                 );
              rTimer.Start();
        }

        public override void xRedraw()
        {
            int i, N = tc.q.Count;

            Graphics gr = Graphics.FromImage(base.bmp);

            r.drawRessore(gr, rPen, base.rPoint);
            c.drawCargo(gr, cPen, cBr, base.rPoint);

            for (i = 0; N > 0 && i < N; i++) ((Cargo00)tc.xQueue).drawCargo(gr, ctrPen, ctrBr, base.rPoint);

            gr.Dispose();
        }

        //     Layout.
        //       .
        public override void Form_Layout(object sender, LayoutEventArgs e)
        {
            base.Form_Layout(sender, e);
        }

        private void rTimer_Tick(object sender, EventArgs e)
        {
            fc.Demo01(); //        .            
            base.ClearBMP(); //    .
        }
    }
}