using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Data;
using System.Windows.Forms;

namespace StrangeControls
{
/// <summary>
/// Summary description for RoundButton.
///   RoundButton     
///  Button,   
/// -   
///  OnPaint    ImageList. 
/// </summary>
public class RoundButton : Button
{
ImageList imgList;
//     
//     .  
//    ,   
// . 
// ,     
//   .
//      
//  indexB,     
//   .
//     
//   ,    () .  

int indexB; 

public RoundButton():base()
{
	indexB = 0;
	imgList = new ImageList();
	imgList.Images.Add(Image.FromFile(@"jpg0.jpg"));
	imgList.Images.Add(Image.FromFile(@"jpg1.jpg"));
	imgList.Images.Add(Image.FromFile(@"jpg2.jpg"));
	imgList.Images.Add(Image.FromFile(@"jpg3.jpg"));
	this.ImageList=imgList;
	
}

// ,     .
//       
// Refresh(). 
protected override void OnPaint(PaintEventArgs e)
{
	GraphicsPath gp = new GraphicsPath();
    gp.AddEllipse(10,10,50,50);
    Region reg = new Region(gp);         
    //  Region    -  ! 
	this.Region = reg;
    e.Graphics.DrawImage(ImageList.Images[indexB],10,10,50,50);
}

protected override void OnClick(EventArgs e)
{
	indexB = 0;
	this.Refresh();
	base.OnClick (e);
}

protected override void OnMouseDown(MouseEventArgs e)
{
	indexB = 1;
	this.Refresh();
	base.OnMouseDown (e);
}

protected override void OnGotFocus(EventArgs e)
{
	indexB = 0;
	this.Refresh();
	base.OnGotFocus (e);
}

protected override void OnLostFocus(EventArgs e)
{
	indexB = 0;
	this.Refresh();
	base.OnLostFocus(e);
}

protected override void OnMouseEnter(EventArgs e)
{
	indexB = 2;
	this.Refresh();
	base.OnMouseEnter (e);
}

protected override void OnMouseLeave(EventArgs e)
{
	indexB = 3;
	this.Refresh();
	base.OnMouseLeave (e);
}

private void InitializeComponent()
{
	// 
	// RoundButton
	// 
}
}
}
