using System;
using System.Drawing;
using System.Collections.Generic;
using System.Text;

namespace Win3dApp00
{
    class Cube
    {
       public Point3d[] w;
       public PointF[]  v;
 
       public Matrix3d mWrk; // . 
       public Matrix3d mTr;  // .
 
        public Cube(float s)
        {
            w = new Point3d[8];
            v = new PointF[8];

            w[0] = new Point3d(5*s, 5*s, 5*s);
            w[1] = new Point3d(  s, 5*s, 5*s);
            w[2] = new Point3d(5*s,   s, 5*s);
            w[3] = new Point3d(  s,   s, 5*s);
            w[4] = new Point3d(5*s, 5*s,   s);
            w[5] = new Point3d(  s, 5*s,   s);
            w[6] = new Point3d(5*s,   s,   s);
            w[7] = new Point3d(  s,   s,   s);

            mWrk = new Matrix3d();
            mTr  = new Matrix3d();
        }

        public Cube(float s, float d)
        {
            w = new Point3d[8];
            v = new PointF[8];

            w[0] = new Point3d(s + d, s + d, s + d);
            w[1] = new Point3d(s, s + d, s + d);
            w[2] = new Point3d(s + d, s, s + d);
            w[3] = new Point3d(s, s, s + d);
            w[4] = new Point3d(s + d, s + d, s);
            w[5] = new Point3d(s, s + d, s);
            w[6] = new Point3d(s + d, s, s);
            w[7] = new Point3d(s, s, s);

            mWrk = new Matrix3d();
            mTr = new Matrix3d();
        }

        
        
        //     .
        //        . 
        public void Move(float x, float y, float z)
        {
            int i;
            for (i = 0; i < 8; i++)
            {
                w[i].x += x;
                w[i].y += y;
                w[i].z += z;
            }
        
        }

        public void Cube2dTransformation()
        {
            int i;
         
            //     .
            for (i = 0; i < 8; i++)
            {
                v[i] = mTr.Transformation2d(w[i], 1.0F);
            }           
        }
         
        public void DrawCube(Graphics gr, Pen p, Pen[] pp, double rp)
        { 
          int i,j;
          for (i = 0; i < 8; i++)
          {
              for (j = 0; j < 8; j++)
              {
                  gr.DrawLine(p, (float)(v[i].X * rp),
                                 (float)(v[i].Y * rp),
                                 (float)(v[j].X * rp),
                                 (float)(v[j].Y * rp));
                  
              }
              gr.DrawEllipse(pp[i],
                                (float)((v[i].X - 1) * rp),
                                (float)((v[i].Y - 1) * rp),
                                (float)(2 * rp),
                                (float)(2 * rp));
          }           
        }
    }
}
