using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace winLibrary00
{
    public partial class xForm00 : Form
    {
        //  .   .
        public double rPoint;
        Size borderSize;
        public Bitmap bmp;
        Color xBackColor;
        Color xPenColor;
        Pen gridPen;

        public xForm00()
        {
        }

        public xForm00(Color xBC, Color xPC)
        {
          xBackColor = xBC;
          xPenColor = xPC;
          gridPen = new Pen(xPenColor,1);
          InitializeComponent();
          borderSize = new Size(this.Size.Width - this.ClientSize.Width, this.Size.Height - this.ClientSize.Height);
          this.MaximumSize = new Size(950 + borderSize.Width, 950 + borderSize.Height);
          this.MinimumSize = new Size(100 + borderSize.Width, 100 + borderSize.Height);
      }
        
        public void ClearBMP()
        {
            Graphics gr = Graphics.FromImage(bmp);
            gr.Clear(xBackColor);
            gr.Dispose();
            SetGrid();
            xRedraw();
            xPictureBox.Image = bmp;
        }

        public void SetGrid()
        {
            Graphics gr = Graphics.FromImage(bmp);
            float x, i = (float)(this.ClientSize.Width / 25.0F), y, j = (float)(this.ClientSize.Height/25.0F);
            float N = this.ClientSize.Width, M = this.ClientSize.Height;
            for (x = 0; x < N; x += i)
            {
                gr.DrawLine(gridPen, x, 0, x, M);       
            }
            for (y = 0; y < M; y += j)
            {
                gr.DrawLine(gridPen, 0, y, N, y);
            }
            gr.Dispose();
        }

        //    rPoint   .
        //   !
        //      .
        //          value!
        private Size rPointSet
        {
            set
            {
                Size s = value;
                rPoint = Math.Sqrt(2.0 * s.Width * s.Height) * 0.002;
            }
        }

        //      .
        //       - 
        //    .  ,   
        //       .
        //         
        //  -      .
        public virtual void xRedraw()
        {
        
        }

        // -  Layout.
        // Ÿ     xForm00_Layout.   
        //     .
        public virtual void Form_Layout(object sender, LayoutEventArgs e)
        {
            this.Size = new Size
            (
             (this.ClientSize.Width + this.ClientSize.Height) / 2 + borderSize.Width,
             (this.ClientSize.Width + this.ClientSize.Height) / 2 + borderSize.Height
            );
            if (this.ClientSize.Width > 0 && this.ClientSize.Height > 0)
            {
                rPointSet = this.ClientSize;
                bmp = new Bitmap(this.ClientSize.Width, this.ClientSize.Height);
                ClearBMP();
            }
        }

    }
}